//----------------------------------------------------------------------//
// NyanFi																//
//  ^Oݒ/														//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "TagDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTagManDlg *TagManDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TTagManDlg::TTagManDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::FormCreate(TObject *Sender)
{
	Initialized = false;
	IsFind = false;
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	set_ListBoxItemHi(TagCheckListBox);
	usr_TAG->IniCheckList(TagCheckListBox);

	if (IsFind) {
		Caption = "^O";
		AndCheckBox->Visible = true;
		AndCheckBox->Checked = IniFile->ReadBoolGen(_T("FindTagDlgAnd"),	false);
	}
	else {
		Caption = "^Oݒ";
		AndCheckBox->Visible = false;

		TStringDynArray org_lst = split_strings_semicolon(TagEdit->Text);
		for (int i=0; i<org_lst.Length; i++) {
			int idx = TagCheckListBox->Items->IndexOf(org_lst[i]);
			if (idx!=-1) TagCheckListBox->Checked[idx] = true;
		}
	}

	::PostMessage(Handle, WM_FORM_SHOWED, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::WmFormShowed(TMessage &msg)
{
	TagEdit->Hint = LoadUsrMsg(USTR_HintMltSepSC);
	TagEdit->SelStart = TagEdit->Text.Length();
	TagEdit->SetFocus();

	Initialized = true;
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	if (IsFind) IniFile->WriteBoolGen(_T("FindTagDlgAnd"),	AndCheckBox);

	IsFind = false;
	Initialized = false;
}

//---------------------------------------------------------------------------
void __fastcall TTagManDlg::TagEditChange(TObject *Sender)
{
	if (!Initialized) return;

	TStringDynArray org_lst = split_strings_semicolon(TagEdit->Text);
	std::unique_ptr<TStringList> lst(new TStringList());
	for (int i=0; i<org_lst.Length; i++) {
		UnicodeString tnam = org_lst[i];
		if (!tnam.IsEmpty()) lst->Add(tnam);
	}

	for (int i=0; i<TagCheckListBox->Count; i++) {
		UnicodeString tnam = TagCheckListBox->Items->Strings[i];
		TagCheckListBox->Checked[i] = (lst->IndexOf(tnam)!=-1);
	}

	TagCheckListBoxClickCheck(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TTagManDlg::TagCheckListBoxClickCheck(TObject *Sender)
{
	if (!Initialized) return;

	UnicodeString lbuf = usr_TAG->CheckToTags(TagCheckListBox, TagEdit->Text);
	if (!SameStr(lbuf, TagEdit->Text)) {
		TagEdit->Enabled  = false;
		TagEdit->Text	  = lbuf;
		TagEdit->Enabled  = true;
		TagEdit->SetFocus();
		TagEdit->SelStart = TagEdit->Text.Length();
	}
}

//---------------------------------------------------------------------------
//^O̕ύX
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::RenTagActionExecute(TObject *Sender)
{
	int idx = TagCheckListBox->ItemIndex;
	if (idx==-1) return;

	UnicodeString old_tag = TagCheckListBox->Items->Strings[idx];
	UnicodeString new_tag = old_tag;
	if (input_query_ex(_T("^O̕ύX"), _T("^O"), &new_tag) && !SameStr(old_tag, new_tag)) {
		int cnt = usr_TAG->RenTag(old_tag, new_tag);
		usr_TAG->IniCheckList(TagCheckListBox, new_tag);
		if (cnt>0) msgbox_OK(UnicodeString().sprintf(_T("%uڂ̃^OݒXV܂B"), cnt));
	}
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::RenTagActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = (TagCheckListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//݂Ȃڂ̃f[^폜
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::UpdDataActionExecute(TObject *Sender)
{
	if (msgbox_Sure(LoadUsrMsg(USTR_DeleteQ, _T("݂Ȃڃf[^")), SureDelete)) {
		cursor_HourGlass();
		int cnt = usr_TAG->UpdateItems();
		cursor_Default();

		UnicodeString msg;
		if (cnt>0)
			msg.sprintf(_T("%u ̃f[^폜܂B"), cnt);
		else
			msg.USET_T("݂Ȃڃf[^͂܂łB");
		msgbox_OK(msg);
	}
}
//---------------------------------------------------------------------------
void __fastcall TTagManDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString topic = HELPTOPIC_FL;
	if (IsFind) topic.UCAT_T("#FindTag"); else topic.UCAT_T("#SetTag");
	SpecialKeyProc(this, Key, Shift, topic.c_str());
}
//---------------------------------------------------------------------------

