//----------------------------------------------------------------------//
// ^OǗ																//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <System.StrUtils.hpp>
#include "usr_str.h"
#include "usr_file_ex.h"
#include "usr_tag.h"

//---------------------------------------------------------------------------
TagManager::TagManager(UnicodeString fnam)
{
	TagDataList = new TStringList();
	TagNameList = new TStringList();

	FileName = fnam;
	if (FileExists(FileName)) {
		TagDataTime = get_file_age(FileName);
		TagDataList->LoadFromFile(FileName);
		Modified = false;
		MakeTagNameList();
	}
}
//---------------------------------------------------------------------------
TagManager::~TagManager()
{
	delete TagDataList;
	delete TagNameList;
}

//---------------------------------------------------------------------------
//t@CXV
//---------------------------------------------------------------------------
bool TagManager::UpdateFile()
{
	try {
		if (Modified) {
			TagDataList->SaveToFile(FileName, TEncoding::UTF8);
			TagDataTime = get_file_age(FileName);
			Modified = false;
		}
		return true;
	}
	catch (...) {
		return false;
	}
}

//---------------------------------------------------------------------------
//^OXg쐬
//---------------------------------------------------------------------------
void TagManager::MakeTagNameList()
{
	for (int i=0; i<TagDataList->Count; i++) {
		UnicodeString lbuf = TagDataList->Strings[i];
		TStringDynArray tag_lst = split_strings_semicolon(get_post_tab(lbuf));
		for (int j=0; j<tag_lst.Length; j++) {
			UnicodeString tag = tag_lst[j];
			if (TagNameList->IndexOf(tag)==-1) TagNameList->Add(tag);
		}
	}
	TagNameList->Sort();
}

//---------------------------------------------------------------------------
//^CX^vωĂēǂݍ
//---------------------------------------------------------------------------
bool TagManager::Recycle()
{
	if (!FileExists(FileName)) return false;

	TDateTime ft = get_file_age(FileName);
	if (TagDataTime!=ft) {
		TagDataTime = ft;
		TagDataList->LoadFromFile(FileName);
		Modified = false;
		MakeTagNameList();
		return true;
	}
	else
		return false;
}

//---------------------------------------------------------------------------
//݂Ȃڂ폜
//---------------------------------------------------------------------------
int TagManager::UpdateItems()
{
	int cnt = 0;
	int i = 0;
	while (i<TagDataList->Count) {
		if (!file_exists(get_pre_tab(TagDataList->Strings[i]))) {
			TagDataList->Delete(i); cnt++;
		}
		else i++;
	}

	if (cnt>0) Modified = true;
	UpdateFile();

	return cnt;
}

//---------------------------------------------------------------------------
//t@CECfbNX擾
//---------------------------------------------------------------------------
int TagManager::GetIndex(UnicodeString fnam)
{
	UnicodeString f_str = fnam + "\t";
	int idx = -1;
	for (int i=0; i<TagDataList->Count; i++) {
		if (StartsText(f_str, TagDataList->Strings[i])) {
			idx = i; break;
		}
	}
	return idx;
}

//---------------------------------------------------------------------------
//^O擾
//---------------------------------------------------------------------------
UnicodeString TagManager::GetTags(UnicodeString fnam)
{
	int idx = GetIndex(fnam);
	return ((idx!=-1)? get_post_tab(TagDataList->Strings[idx]) : EmptyStr);
}

//---------------------------------------------------------------------------
//wt@C̃^O폜
//---------------------------------------------------------------------------
void TagManager::DelItem(UnicodeString fnam)
{
	int idx = GetIndex(fnam);
	if (idx!=-1) {
		TagDataList->Delete(idx);
		Modified = true;
	}
}

//---------------------------------------------------------------------------
//^Oݒ
//---------------------------------------------------------------------------
void TagManager::SetTags(
	UnicodeString fnam,		//t@C
	UnicodeString tags)		//ǉ^O(;؂)
{
	TStringDynArray add_lst = split_strings_semicolon(tags);
	tags = EmptyStr;
	for (int i=0; i<add_lst.Length; i++) {
		UnicodeString tnam = add_lst[i];
		if (tnam.IsEmpty()) continue;
		if (TagNameList->IndexOf(tnam)==-1) TagNameList->Add(tnam);
		if (!tags.IsEmpty()) tags += ";";
		tags += tnam;
	}
	TagNameList->Sort();

	int idx = GetIndex(fnam);
	if (idx!=-1) {
		if (!tags.IsEmpty())
			TagDataList->Strings[idx] = fnam + "\t" + tags;
		else
			TagDataList->Delete(idx);
	}
	else if (!tags.IsEmpty()) {
		TagDataList->Add(fnam + "\t" + tags);
	}

	Modified = true;
}

//---------------------------------------------------------------------------
//^Oǉ
//---------------------------------------------------------------------------
void TagManager::AddTags(UnicodeString fnam, UnicodeString tags)
{
	TStringDynArray add_lst = split_strings_semicolon(tags);
	tags = EmptyStr;
	for (int i=0; i<add_lst.Length; i++) {
		if (add_lst[i].IsEmpty()) continue;
		if (!tags.IsEmpty()) tags += ";";
		tags += add_lst[i];
	}
	if (tags.IsEmpty()) return;

	int idx = GetIndex(fnam);
	if (idx!=-1) {
		UnicodeString lbuf = TagDataList->Strings[idx];
		UnicodeString   tag_str = get_post_tab(lbuf);
		TStringDynArray tag_lst = split_strings_semicolon(tag_str);
		for (int j=0; j<add_lst.Length; j++) {
			if (add_lst[j].IsEmpty()) continue;
			bool found = false;
			for (int k=0; k<tag_lst.Length && !found; k++) {
				found = SameText(add_lst[j], tag_lst[k]);
			}
			if (!found) {
				if (!tag_str.IsEmpty() && !EndsStr(";", tag_str)) tag_str.UCAT_T(";");
				tag_str += add_lst[j];
			}
		}
		TagDataList->Strings[idx] = fnam + "\t" + tag_str;
	}
	else {
		TagDataList->Add(fnam + "\t" + tags);
	}

	Modified = true;
}

//---------------------------------------------------------------------------
//^Ỏ
//---------------------------------------------------------------------------
int TagManager::RenTag(UnicodeString old_tag, UnicodeString new_tag)
{
	int idx = TagNameList->IndexOf(old_tag);
	if (idx!=-1) TagNameList->Strings[idx] = new_tag;

	int total = 0;
	for (int i=0; i<TagDataList->Count; i++) {
		UnicodeString lbuf = TagDataList->Strings[i];
		UnicodeString fnam = get_pre_tab(lbuf);
		TStringDynArray tag_lst = split_strings_semicolon(get_post_tab(lbuf));
		UnicodeString new_tags;
		int cnt = 0;
		for (int j=0; j<tag_lst.Length; j++) {
			if (SameText(old_tag, tag_lst[j])) {
				tag_lst[j] = new_tag; cnt++;
			}
			if (!new_tags.IsEmpty()) new_tags.UCAT_T(";");
			new_tags += tag_lst[j];
		}

		if (cnt>0) {
			TagDataList->Strings[i] = fnam + "\t" + new_tags;
			total += cnt;
		}
	}

	if (total>0) Modified = true;
	UpdateFile();

	return total;
}

//---------------------------------------------------------------------------
//^O`FbNXg̏
//---------------------------------------------------------------------------
void TagManager::IniCheckList(TCheckListBox *lp, UnicodeString tnam)
{
	lp->Items->Assign(TagNameList);
	for (int i=0; i<lp->Count; i++) lp->Checked[i] = false;

	if (!tnam.IsEmpty()) lp->ItemIndex = lp->Items->IndexOf(tnam);
}

//---------------------------------------------------------------------------
//Xg`FbN{bNX^Oւ̔f
//---------------------------------------------------------------------------
UnicodeString TagManager::CheckToTags(TCheckListBox *lp, UnicodeString tags)
{
	bool end_sc = EndsStr(";", tags);
	TStringDynArray org_lst = split_strings_semicolon(tags);
	std::unique_ptr<TStringList> lst(new TStringList());
	for (int i=0; i<org_lst.Length; i++) {
		UnicodeString tnam = org_lst[i];
		if (!tnam.IsEmpty()) lst->Add(tnam);
	}

	for (int i=0; i<lp->Count; i++) {
		UnicodeString tnam = lp->Items->Strings[i];
		int idx = lst->IndexOf(tnam);
		if (idx==-1 && lp->Checked[i])
			lst->Add(tnam);
		else if (idx!=-1 && !lp->Checked[i])
			lst->Delete(idx);
	}

	UnicodeString ret_str, tag1;
	for (int i=0; i<lst->Count; i++) {
		UnicodeString tnam = lst->Strings[i];
		int idx = lp->Items->IndexOf(tnam);
		if (idx!=-1) {
			if (!ret_str.IsEmpty()) ret_str.UCAT_T(";");
			ret_str += lp->Items->Strings[idx];
		}
		else {
			if (!tag1.IsEmpty()) tag1.UCAT_T(";");
			tag1 += tnam;
		}
	}

	if (!tag1.IsEmpty()) {
		if (!ret_str.IsEmpty()) ret_str.UCAT_T(";");
		ret_str += tag1;
	}

	if (end_sc) ret_str.UCAT_T(";");

	return ret_str;
}
//---------------------------------------------------------------------------
